Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPolygon Class Reference

`#include <vtkPolygon.h>`

Inheritance diagram for vtkPolygon:

[legend]
Collaboration diagram for vtkPolygon:

[legend]
List of all members.

## Detailed Description

a cell that represents an n-sided polygon

Date:
  2002/12/26 18:24:21

Revision:
  1.74

vtkPolygon is a concrete implementation of vtkCell to represent a 2D n-sided polygon. The polygons cannot have any internal holes, and cannot self-intersect. Define the polygon with n-points ordered in the clockwise direction; do not repeat the last point.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (70%)
  - Martin, Ken (10%)
  - Miller, Jim (7%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkPolygon.h)`
  - .`cxx` (`/Common/vtkPolygon.cxx)`

Examples:
  vtkPolygon (Examples)

Tests:
  vtkPolygon (Tests)

Definition at line 57 of file vtkPolygon.h.

## Public Types
typedef vtkCell | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | ComputeWeights (float x[3], float *weights)
int | Triangulate (vtkIdList *outTris)
int | GetCellType ()
int | GetCellDimension ()
int | GetNumberOfEdges ()
int | GetNumberOfFaces ()
vtkCell * | GetEdge (int edgeId)
vtkCell * | GetFace (int)
int | CellBoundary (int subId, float pcoords[3], vtkIdList *pts)
void | Contour (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd)
void | Clip (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *tris, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut)
int | EvaluatePosition (float x[3], float *closestPoint, int &subId, float pcoords[3], float &dist2, float *weights)
void | EvaluateLocation (int &subId, float pcoords[3], float x[3], float *weights)
int | IntersectWithLine (float p1[3], float p2[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts)
void | Derivatives (int subId, float pcoords[3], float *values, int dim, float *derivs)
int | ParameterizePolygon (float p0[3], float p10[3], float &l10, float p20[3], float &l20, float n[3])
## Static Public Methods
vtkPolygon * | New ()
int | IsTypeOf (const char *type)
vtkPolygon * | SafeDownCast (vtkObject *o)
void | ComputeNormal (int numPts, float *pts, float n[3])
void | ComputeNormal (vtkPoints *p, int numPts, vtkIdType *pts, float n[3])
void | ComputeNormal (vtkPoints *p, float n[3])
int | PointInPolygon (float x[3], int numPts, float *pts, float bounds[6], float n[3])
int | IntersectPolygonWithPolygon (int npts, float *pts, float bounds[6], int npts2, float *pts2, float bounds2[3], float tol, float x[3])
## Protected Methods
| vtkPolygon ()
| ~vtkPolygon ()
int | EarCutTriangulation ()
## Protected Attributes
float | Tolerance
int | SuccessfulTriangulation
float | Normal [3]
vtkIdList * | Tris
vtkTriangle * | Triangle
vtkQuad * | Quad
vtkFloatArray * | TriScalars
vtkLine * | Line

## Member Typedef Documentation

typedef vtkCell vtkPolygon::Superclass

| Reimplemented from vtkCell. Definition at line 61 of file vtkPolygon.h.

## Constructor & Destructor Documentation

vtkPolygon::vtkPolygon | ( |  | ) | `[protected]`

vtkPolygon::~vtkPolygon | ( |  | ) | `[protected]`

## Member Function Documentation

vtkPolygon* vtkPolygon::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkPolygon::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkCell.

int vtkPolygon::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell.

virtual int vtkPolygon::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell.

vtkPolygon* vtkPolygon::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkCell.

int vtkPolygon::GetCellType | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 65 of file vtkPolygon.h. References VTK_POLYGON.

int vtkPolygon::GetCellDimension | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 66 of file vtkPolygon.h.

int vtkPolygon::GetNumberOfEdges | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 67 of file vtkPolygon.h. References vtkCell::GetNumberOfPoints().

int vtkPolygon::GetNumberOfFaces | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 68 of file vtkPolygon.h.

vtkCell* vtkPolygon::GetEdge | ( | int | edgeId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

vtkCell* vtkPolygon::GetFace | ( | int |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 70 of file vtkPolygon.h.

int vtkPolygon::CellBoundary | ( | int | subId,
|  | float | pcoords[3],
|  | vtkIdList * | pts
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPolygon::Contour | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPolygon::Clip | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | tris,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd,
|  | int | insideOut
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPolygon::EvaluatePosition | ( | float | x[3],
|  | float * | closestPoint,
|  | int & | subId,
|  | float | pcoords[3],
|  | float & | dist2,
|  | float * | weights
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPolygon::EvaluateLocation | ( | int & | subId,
|  | float | pcoords[3],
|  | float | x[3],
|  | float * | weights
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPolygon::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkPolygon::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPolygon::Derivatives | ( | int | subId,
|  | float | pcoords[3],
|  | float * | values,
|  | int | dim,
|  | float * | derivs
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkPolygon::ComputeNormal | ( | vtkPoints * | p,
|  | int | numPts,
|  | vtkIdType * | pts,
|  | float | n[3]
| ) | `[static]`

| Polygon specific methods.

void vtkPolygon::ComputeNormal | ( | vtkPoints * | p,
|  | float | n[3]
| ) | `[static]`

| Polygon specific methods.

void vtkPolygon::ComputeNormal | ( | int | numPts,
|  | float * | pts,
|  | float | n[3]
| ) | `[static]`

| Compute the polygon normal from an array of points. This version assumes that the polygon is convex, and looks for the first valid normal.

void vtkPolygon::ComputeWeights | ( | float | x[3],
|  | float * | weights
| ) |

| Compute interpolation weights using 1/r**2 normalized sum.

int vtkPolygon::ParameterizePolygon | ( | float | p0[3],
|  | float | p10[3],
|  | float & | l10,
|  | float | p20[3],
|  | float & | l20,
|  | float | n[3]
| ) |

| Create a local s-t coordinate system for a polygon. The point p0 is the origin of the local system, p10 is s-axis vector, and p20 is the t-axis vector. (These are expressed in the modeling coordinate system and are vectors of dimension [3].) The values l20 and l20 are the lengths of the vectors p10 and p20, and n is the polygon normal.

int vtkPolygon::PointInPolygon | ( | float | x[3],
|  | int | numPts,
|  | float * | pts,
|  | float | bounds[6],
|  | float | n[3]
| ) | `[static]`

| Determine whether point is inside polygon. Function uses ray-casting to determine if point is inside polygon. Works for arbitrary polygon shape (e.g., non-convex). Returns 0 if point is not in polygon; 1 if it is. Can also return -1 to indicate degenerate polygon.

int vtkPolygon::Triangulate | ( | vtkIdList * | outTris | ) |

| Triangulate this polygon. The user must provide the vtkIdList outTris. On output, the outTris list contains the ids of the points defining the triangulation. The ids are ordered into groups of three: each three-group defines one triangle.

int vtkPolygon::IntersectPolygonWithPolygon | ( | int | npts,
|  | float * | pts,
|  | float | bounds[6],
|  | int | npts2,
|  | float * | pts2,
|  | float | bounds2[3],
|  | float | tol,
|  | float | x[3]
| ) | `[static]`

| Method intersects two polygons. You must supply the number of points and point coordinates (npts, *pts) and the bounding box (bounds) of the two polygons. Also supply a tolerance squared for controlling error. The method returns 1 if there is an intersection, and 0 if not. A single point of intersection x[3] is also returned if there is an intersection.

int vtkPolygon::EarCutTriangulation | ( |  | ) | `[protected]`

| A fast triangulation method. Uses recursive divide and conquer based on plane splitting to reduce loop into triangles. The cell (e.g., triangle) is presumed properly initialized (i.e., Points and PointIds).

## Member Data Documentation

float vtkPolygon::Tolerance`[protected]`

| Definition at line 153 of file vtkPolygon.h.

int vtkPolygon::SuccessfulTriangulation`[protected]`

| Definition at line 154 of file vtkPolygon.h.

float vtkPolygon::Normal[3]`[protected]`

| Definition at line 155 of file vtkPolygon.h.

vtkIdList* vtkPolygon::Tris`[protected]`

| Definition at line 156 of file vtkPolygon.h.

vtkTriangle* vtkPolygon::Triangle`[protected]`

| Definition at line 157 of file vtkPolygon.h.

vtkQuad* vtkPolygon::Quad`[protected]`

| Definition at line 158 of file vtkPolygon.h.

vtkFloatArray* vtkPolygon::TriScalars`[protected]`

| Definition at line 159 of file vtkPolygon.h.

vtkLine* vtkPolygon::Line`[protected]`

| Definition at line 160 of file vtkPolygon.h.

The documentation for this class was generated from the following file:

- Common/vtkPolygon.h